# Alphacode



Este projeto tem como objetivo integrar os pedidos delivery da Alphacode.
A integração funciona de forma autônoma, desde o recebimento do pedido no parceiro até o envio do mesmo a cozinha do restaurante.


## Framework
- [Slim v3](https://www.slimframework.com/docs/v3/) 

## Dependências
### Backend
- Composer - [composer.json](http://gitlab.teknisa.com/odhen/integrations/alphacode/-/blob/master/backend/composer.json)

## Arquivos Estruturais
### Backend
#### Arquivos de Configuração
- [env.ini](http://gitlab.teknisa.com/odhen/integrations/alphacode/-/blob/master/backend/env.ini) - Responsável pelo apontamento de qual cliente a integração deverá considerar em sua execução
- [configs.json](http://gitlab.teknisa.com/odhen/integrations/alphacode/-/blob/master/backend/presets/configs/configs_cloud9.json) - Responsável por definir as credenciais de acesso a API, Apontamento de SMTP, diretório de logs e constantes da API
- [environment.json](http://gitlab.teknisa.com/odhen/integrations/alphacode/-/blob/master/backend/presets/clients/external/cloud9/environment.json) - Reponsável pelas configurações de conexão com o banco de dados (OracleDB)


## Instalação
### Desenvolvimento
1. Com o projeto clonado no seu ambiente Cloud, acesse a pasta ***Backend*** e altere o arquivo [env.ini] com as seguintes informações:
```ini
EXTERNAL_CLIENT_PRESET=cloud9
```

2. Acesse a pasta ***Backend/Configs*** e altere o arquivo [configs.json] com a seguintes informações:
```json
{
    "client"     : "Teknisa",
    "server"     : "cloud9",
    "logPath"    : "/home/developer/workfolder/logs/alphacode",

    "host"       : "email-smtp.us-east-1.amazonaws.com",
    "username"   : "AKIAZRKH2SFLKRV4RZW5",
    "from"       : "no-reply@teknisa.com",
    "password"   : "R0hqSHpobEZzS1NCR0pKTjRPaEhVaWhHdW1qN21uUndqY2o2cjJTVjNsUnVoMG5OQlJtWVE0OEU0QzdrZ3NuQQ==",
    "SMTPSecure" : "tls",
    "port"       : 587,
    
    "timezone"   : "SP",
    
    "failoverEmail": "delivery@teknisa.com",
    "apiURL"       : "http://192.168.120.98:9091/odhen-ifood-bench/src/public/index.php/",
    "webhookURL"   : "http://danielsantos1.zeedhi.com/workfolder/ifood/webhook/index.php/"
}
```
3. Acesse a pasta ***backend/presets/clients/*** copie a pasta [(cloud9)] junto de seus sub-diretórios e cole dentro de ***backend/clients/external***. 

**OBS: Importante manter somente a pasta cloud9 no diretorio "backend/clients/external" afim de evitar que erro no apontamento de cliente gere maiores impactos.***

4. Pelo terminal, acesse a pasta ***backend*** e execute o seguinte comando:
```
composer install
```

#### Constantes dentro de configs.json
- **failoverEmail** - Email utilizado caso a integração não encontre uma lista válida de e-mails cadastrados em caso de erro.
- **apiURL** - URL da API do Alphacode. Existem duas versões, uma para homologação e outra para produção.
  - URL Homologação: https://hm.merchant-api.alphacode.com.br/
  - URL Produção: https://merchant-api.alphacode.com.br/
- **webhookURL** - URL do Webhook utilizado pela Alphacode. O Madero possui duas versões, uma para homologação e outra para produção.
  - URL Homologação: https://integracao-alphacode-hml.grupomadero.com.br/webhook/index.php
  - URL Produção: https://integracao-alphacode.grupomadero.com.br/webhook/index.php/